<!DOCTYPE html>
<html lang="en" prefix="og: http://ogp.me/ns#">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  <meta http-equiv="Content-Language" content="en-us" />
  <meta http-equiv="imagetoolbar" content="false" />
  <meta name="MSSmartTagsPreventParsing" content="true" />
  <meta name="viewport" content="width=device-width,initial-scale=1">
  <title>Forming Calls with GraphQL | GitHub Developer Guide</title>
  <meta property="og:url" content="https://developer.github.com/v4/guides/forming-calls/" />
<meta property="og:site_name" content="GitHub Developer" />
<meta property="og:title" content="Forming Calls with GraphQL" />
<meta property="og:description" content="Get started with one of our guides, or jump straight into the API documentation." />
<meta property="og:type" content="website" />
<meta property="og:author" content="https://www.facebook.com/GitHub" />
<meta property="og:image" content="https://og.github.com/logo/github-logo@1200x1200.png" />
<meta property="og:image:width" content="1200" />
<meta property="og:image:height" content="1200" />
<meta property="og:image" content="https://og.github.com/mark/github-mark@1200x630.png" />
<meta property="og:image:width" content="1200" />
<meta property="og:image:height" content="630" />
<meta property="og:image" content="https://og.github.com/octocat/github-octocat@1200x630.png" />
<meta property="og:image:width" content="1200" />
<meta property="og:image:height" content="630" />
<meta property="twitter:card" content="summary_large_image" />
<meta property="twitter:site" content="@github" />
<meta property="twitter:site:id" content="13334762" />
<meta property="twitter:creator" content="@githubapi" />
<meta property="twitter:creator:id" content="@539153822" />
<meta property="twitter:title" content="Forming Calls with GraphQL" />
<meta property="twitter:description" content="Get started with one of our guides, or jump straight into the API documentation." />
<meta property="twitter:image:src" content="https://og.github.com/logo/github-logo@1200x1200.png" />
<meta property="twitter:image:width" content="1200" />
<meta property="twitter:image:height" content="1200" />

  
  <link rel="alternate" type="application/atom+xml" title="API Changes" href="/changes.atom" />
  
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:400,300,400italic,500">
  <link href="/assets/stylesheets/application.css" rel="stylesheet" type="text/css" />
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/2.1.4/jquery.min.js"></script>
  <script src="/assets/javascripts/application.js" type="text/javascript"></script>
  
</head>


<body class="api ">
  

<header class="site-header">
  <div id="header" class="container">
    <a class="site-header-logo mt-1" href="/"><img src="/assets/images/github-developer-logo.svg" alt="GitHub Developer"></a>
    <nav class="site-header-nav" aria-label="Main Navigation">
      <div class="dropdown" id="api-docs-dropdown">
          <div class="dropdown-button" tabIndex="0" aria-haspopup="true" aria-expanded="false"><span class="dropdown-button-link" tabIndex="-1">Docs</span> <div class="dropdown-caret"></div></div>
          <div id="js-dropdown-menu" class="dropdown-menu">
            <a class="dropdown-menu-item" href="/apps/">Apps</a>
            <a class="dropdown-menu-item" href="/actions/">GitHub Actions</a>
            <a class="dropdown-menu-item" href="/marketplace/">GitHub Marketplace</a>
            <a class="dropdown-menu-item" href="/webhooks/">Webhooks</a>
            <a class="dropdown-menu-item" href="/partnerships/">Partnerships</a>
            <a class="dropdown-menu-item" href="/v3/">REST API v3</a>
            <a class="dropdown-menu-item" href="/v4/">GraphQL API v4</a>
          </div>
      </div>
      <a class="site-header-nav-item" href="/changes/">Blog</a>
      <a class="site-header-nav-item" href="/forum/">Forum</a>
      <div class="dropdown" id="versions-dropdown">
          <div class="dropdown-button" tabIndex="0" aria-haspopup="true" aria-expanded="false"><span class="dropdown-button-link" tabIndex="-1">Versions</span> <div class="dropdown-caret"></div></div>
          <div id="js-dropdown-menu" class="dropdown-menu">
            <a class="dropdown-menu-item" data-proofer-ignore>GitHub.com</a>
            
            <a class="dropdown-menu-item" data-proofer-ignore>GitHub Enterprise Server 2.20</a>
            
            <a class="dropdown-menu-item" data-proofer-ignore>GitHub Enterprise Server 2.19</a>
            
            <a class="dropdown-menu-item" data-proofer-ignore>GitHub Enterprise Server 2.18</a>
            
            <a class="dropdown-menu-item" data-proofer-ignore>GitHub Enterprise Server 2.17</a>
            
          </div>
      </div>
      <form accept-charset="UTF-8" action="#" class="site-header-nav-item site-header-search">
        <label id="search-container" class="mb-0">
          <input type="text" id="searchfield" class="form-control" placeholder="Search…"
            autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false" />
          <div class="cancel-search"></div>
          <ul id="search-results"></ul>
        </label>
      </form>
    </nav>
  </div>
</header>


  <div class="container">
    

























  

 







    <div class="sub-nav mt-5 mb-3">
      <h2><a href="/v4/">GraphQL API v4</a></h2>
      <ul>
  
  <li><a href="/v4/">Reference</a></li>
  <li><a href="/v4/guides/" class="active">Guides</a></li>
  
  <li><a href="/v4/explorer/">Explorer</a></li>
  <li><a href="/v4/changelog/">Changelog</a></li>
  
  
</ul>

    </div>

    <div class="nav-select nav-select-top hide-lg hide-xl">
      <select class="form-select mt-4" onchange="if (this.value) window.location.href=this.value">
  <option value="">Navigate the docs…</option>
  <optgroup label="Guides">
    <option value="/v4/guides/">Overview</option>
    <option value="/v4/guides/intro-to-graphql/">Intro to GraphQL</option>
    <option value="/v4/guides/forming-calls/">Forming Calls</option>
    <option value="/v4/guides/using-global-node-ids/">Using Global Node IDs</option>
    <option value="/v4/guides/migrating-from-rest/">Migrating from REST</option>
    <option value="/v4/guides/using-the-explorer/">Using the Explorer</option>
    <option value="/v4/guides/managing-enterprise-accounts/">Managing enterprise accounts</option>
    <option value="/v4/guides/resource-limitations/">Resource Limitations</option>
  </optgroup>
</select>

    </div>

    <section class="main pt-5 clearfix gut-3" role="main">
      <div class="content col-md-8">
        <h1>
<a id="forming-calls-with-graphql" class="anchor" href="#forming-calls-with-graphql" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Forming Calls with GraphQL</h1>

<ul id="markdown-toc">
<li><a href="#authenticating-with-graphql" id="markdown-toc-authenticating-with-graphql">Authenticating with GraphQL</a></li>
<li><a href="#the-graphql-endpoint" id="markdown-toc-the-graphql-endpoint">The GraphQL endpoint</a></li>
<li><a href="#communicating-with-graphql" id="markdown-toc-communicating-with-graphql">Communicating with GraphQL</a></li>
<li><a href="#about-query-and-mutation-operations" id="markdown-toc-about-query-and-mutation-operations">About query and mutation operations</a></li>
<li><a href="#working-with-variables" id="markdown-toc-working-with-variables">Working with variables</a></li>
<li><a href="#example-query" id="markdown-toc-example-query">Example query</a></li>
<li><a href="#example-mutation" id="markdown-toc-example-mutation">Example mutation</a></li>
<li><a href="#further-reading" id="markdown-toc-further-reading">Further reading</a></li>
</ul>

<h2>
<a id="authenticating-with-graphql" class="anchor" href="#authenticating-with-graphql" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Authenticating with GraphQL</h2>

<p>To communicate with the GraphQL server, you'll need an OAuth token with the right scopes.</p>

<p>Follow the steps in "<a href="https://help.github.com/articles/creating-an-access-token-for-command-line-use/">Creating a personal access token for the command line</a>" to create a token. The scopes you require depends on the type of data you're trying to request. For example, select the <strong>User</strong> scopes to request user data. If you need access to repository information, select the appropriate <strong>Repository</strong> scopes.</p>

<p>To match the behavior of the <a href="/v4/guides/using-the-explorer">GraphQL Explorer</a>, request the following scopes:</p>

<pre><code>user
public_repo
repo
repo_deployment
repo:status
read:repo_hook
read:org
read:public_key
read:gpg_key
</code></pre>

<p>The API notifies you if a resource requires a specific scope.</p>

<h2>
<a id="the-graphql-endpoint" class="anchor" href="#the-graphql-endpoint" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>The GraphQL endpoint</h2>

<p>The REST API v3 has numerous endpoints; the GraphQL API v4 has a single endpoint:</p>

<pre>https://api.github.com/graphql</pre>

<p>The endpoint remains constant no matter what operation you perform.</p>

<h2>
<a id="communicating-with-graphql" class="anchor" href="#communicating-with-graphql" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Communicating with GraphQL</h2>

<p>Because GraphQL operations consist of multiline JSON, GitHub recommends using the <a href="/v4/guides/using-the-explorer">Explorer</a> to make GraphQL calls. You can also use cURL or any other HTTP-speaking library.</p>

<p>In REST, <a href="/v3/#http-verbs">HTTP verbs</a> determine the operation performed. In GraphQL, you'll provide a JSON-encoded body whether you're performing a query or a mutation, so the HTTP verb is <code>POST</code>. The exception is an <a href="/v4/guides/intro-to-graphql#discovering-the-graphql-api">introspection query</a>, which is a simple <code>GET</code> to the endpoint. For more information on GraphQL versus REST, see "<a href="/v4/guides/migrating-from-rest">Migrating from REST to GraphQL</a>."</p>

<p>To query GraphQL using cURL, make a <code>POST</code> request with a JSON payload. The payload must contain a string called <code>query</code>:</p>

<pre class="command-line">
curl -H "Authorization: bearer <em>token</em>" -X POST -d " \
 { \
   \"query\": \"query { viewer { login }}\" \
 } \
" https://api.github.com/graphql
</pre>

<div class="alert tip">

<p><strong>Note</strong>: The string value of <code>"query"</code> must escape newline characters or the schema will not parse it correctly. For the <code>POST</code> body, use outer double quotes and escaped inner double quotes.</p>

</div>

<h2>
<a id="about-query-and-mutation-operations" class="anchor" href="#about-query-and-mutation-operations" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>About query and mutation operations</h2>

<p>The two types of allowed operations in GitHub's GraphQL API are <em>queries</em> and <em>mutations</em>. Comparing GraphQL to REST, queries operate like <code>GET</code> requests, while mutations operate like <code>POST</code>/<code>PATCH</code>/<code>DELETE</code>. The <a href="/v4/mutation/">mutation name</a> determines which modification is executed.</p>

<p>For information about rate limiting, see "<a href="/v4/guides/resource-limitations/">GraphQL resource limitations</a>."</p>

<p>Queries and mutations share similar forms, with some important differences.</p>

<h3>
<a id="about-queries" class="anchor" href="#about-queries" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>About queries</h3>

<p>GraphQL queries return only the data you specify. To form a query, you must specify <a href="/v4/guides/intro-to-graphql#field">fields within fields</a> (also known as <em>nested subfields</em>) until you return only <a href="/v4/scalar/">scalars</a>.</p>

<p>Queries are structured like this:</p>

<pre>query {
  <em>JSON objects to return</em>
}</pre>

<p>For a real-world example, see "<a href="#example-query">Example query</a>."</p>

<h3>
<a id="about-mutations" class="anchor" href="#about-mutations" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>About mutations</h3>

<p>To form a mutation, you must specify three things:</p>

<ol>
<li>
<em>Mutation name</em>. The type of modification you want to perform.</li>
<li>
<em>Input object</em>. The data you want to send to the server, composed of <em>input fields</em>. Pass it as an argument to the mutation name.</li>
<li>
<em>Payload object</em>. The data you want to return from the server, composed of <em>return fields</em>. Pass it as the body of the mutation name.</li>
</ol>

<p>Mutations are structured like this:</p>

<pre>mutation {
  <em>mutationName</em>(input: {<em>MutationNameInput!</em>}) {
    <em>MutationNamePayload</em>
}</pre>

<p>The input object in this example is <code>MutationNameInput</code>, and the payload object is <code>MutationNamePayload</code>.</p>

<p>In the <a href="/v4/mutation/">mutations</a> reference, the listed <em>input fields</em> are what you pass as the input object. The listed <em>return fields</em> are what you pass as the payload object.</p>

<p>For a real-world example, see "<a href="#example-mutation">Example mutation</a>."</p>

<h2>
<a id="working-with-variables" class="anchor" href="#working-with-variables" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Working with variables</h2>

<p><a href="https://graphql.github.io/learn/queries/#variables">Variables</a> can make queries more dynamic and powerful, and they can reduce complexity when passing mutation input objects.</p>

<div class="alert note">

<p><strong>Note</strong>: If you're using the Explorer, make sure to enter variables in the separate <a href="/v4/guides/using-the-explorer/#using-the-variable-pane">Query Variables pane</a>, and do not include the word <code>variables</code> before the JSON object.</p>

</div>

<p>Here's an example query with a single variable:</p>

<p class="explorer-link"><a href="/v4/explorer/?variables=%20%7B%0A%20%20%20%22number_of_repos%22%3A%203%0A%7D&amp;query=query%28%24number_of_repos%3AInt%21%29%20%7B%0A%20%20viewer%20%7B%0A%20%20%20%20name%0A%20%20%20%20%20repositories%28last%3A%20%24number_of_repos%29%20%7B%0A%20%20%20%20%20%20%20nodes%20%7B%0A%20%20%20%20%20%20%20%20%20name%0A%20%20%20%20%20%20%20%7D%0A%20%20%20%20%20%7D%0A%20%20%20%7D%0A%7D%0A">Run in Explorer</a></p>

<pre class="highlight highlight-graphql"><code><span class="k">query</span><span class="p">(</span><span class="nv">$number_of_repos</span><span class="p">:</span><span class="nb">Int</span><span class="p">!)</span><span class="w"> </span><span class="p">{</span><span class="w">
  </span><span class="n">viewer</span><span class="w"> </span><span class="p">{</span><span class="w">
    </span><span class="n">name</span><span class="w">
     </span><span class="n">repositories</span><span class="p">(</span><span class="n">last</span><span class="p">:</span><span class="w"> </span><span class="nv">$number_of_repos</span><span class="p">)</span><span class="w"> </span><span class="p">{</span><span class="w">
       </span><span class="n">nodes</span><span class="w"> </span><span class="p">{</span><span class="w">
         </span><span class="n">name</span><span class="w">
       </span><span class="p">}</span><span class="w">
     </span><span class="p">}</span><span class="w">
   </span><span class="p">}</span><span class="w">
</span><span class="p">}</span><span class="w">
</span><span class="err">variables</span><span class="w"> </span><span class="p">{</span><span class="w">
   </span><span class="err">"</span><span class="n">number_of_repos</span><span class="err">":</span><span class="w"> </span><span class="err">3</span><span class="w">
</span><span class="p">}</span><span class="w">
</span></code></pre>


<p>There are three steps to using variables:</p>

<ol>
<li>
<p>Define the variable outside the operation in a <code>variables</code> object:</p>

<pre class="highlight highlight-graphql"><code><span class="err">variables</span><span class="w"> </span><span class="p">{</span><span class="w">
   </span><span class="err">"</span><span class="n">number_of_repos</span><span class="err">":</span><span class="w"> </span><span class="err">3</span><span class="w">
</span><span class="p">}</span><span class="w">
</span></code></pre>


<p>The object must be valid JSON. This example shows a simple <code>Int</code> variable type, but it's possible to define more complex variable types, such as input objects. You can also define multiple variables here.</p>
</li>
<li>
<p>Pass the variable to the operation as an argument:</p>

<pre class="highlight highlight-graphql"><code><span class="k">query</span><span class="p">(</span><span class="nv">$number_of_repos</span><span class="p">:</span><span class="nb">Int</span><span class="p">!){</span><span class="w">
</span></code></pre>


<p>The argument is a key-value pair, where the key is the <em>name</em> starting with <code>$</code> (e.g., <code>$number_of_repos</code>), and the value is the <em>type</em> (e.g., <code>Int</code>). Add a <code>!</code> to indicate whether the type is required. If you've defined multiple variables, include them here as multiple arguments.</p>
</li>
<li>
<p>Use the variable within the operation:</p>

<pre class="highlight highlight-graphql"><code><span class="err">repositories(last:</span><span class="w"> </span><span class="err">$number_of_repos)</span><span class="w"> </span><span class="p">{</span><span class="w">
</span></code></pre>


<p>In this example, we substitute the variable for the number of repositories to retrieve. We specify a type in step 2 because GraphQL enforces strong typing.</p>
</li>
</ol>

<p>This process makes the query argument dynamic. We can now simply change the value in the <code>variables</code> object and keep the rest of the query the same.</p>

<p>Using variables as arguments lets you dynamically update values in the <code>variables</code> object without changing the query.</p>

<h2>
<a id="example-query" class="anchor" href="#example-query" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Example query</h2>

<p>Let's walk through a more complex query and put this information in context.</p>

<p>The following query looks up the <code>octocat/Hello-World</code> repository, finds the 20 most recent closed issues, and returns each issue's title, URL, and first 5 labels:</p>

<p class="explorer-link"><a href="/v4/explorer/?variables=%7B%7D&amp;query=query%20%7B%0A%20%20repository%28owner%3A%22octocat%22%2C%20name%3A%22Hello-World%22%29%20%7B%0A%20%20%20%20issues%28last%3A20%2C%20states%3ACLOSED%29%20%7B%0A%20%20%20%20%20%20edges%20%7B%0A%20%20%20%20%20%20%20%20node%20%7B%0A%20%20%20%20%20%20%20%20%20%20title%0A%20%20%20%20%20%20%20%20%20%20url%0A%20%20%20%20%20%20%20%20%20%20labels%28first%3A5%29%20%7B%0A%20%20%20%20%20%20%20%20%20%20%20%20edges%20%7B%0A%20%20%20%20%20%20%20%20%20%20%20%20%20%20node%20%7B%0A%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20%20name%0A%20%20%20%20%20%20%20%20%20%20%20%20%20%20%7D%0A%20%20%20%20%20%20%20%20%20%20%20%20%7D%0A%20%20%20%20%20%20%20%20%20%20%7D%0A%20%20%20%20%20%20%20%20%7D%0A%20%20%20%20%20%20%7D%0A%20%20%20%20%7D%0A%20%20%7D%0A%7D">Run in Explorer</a></p>

<pre class="highlight highlight-graphql"><code><span class="k">query</span><span class="w"> </span><span class="p">{</span><span class="w">
  </span><span class="n">repository</span><span class="p">(</span><span class="n">owner</span><span class="p">:</span><span class="s2">"octocat"</span><span class="p">,</span><span class="w"> </span><span class="n">name</span><span class="p">:</span><span class="s2">"Hello-World"</span><span class="p">)</span><span class="w"> </span><span class="p">{</span><span class="w">
    </span><span class="n">issues</span><span class="p">(</span><span class="n">last</span><span class="p">:</span><span class="mi">20</span><span class="p">,</span><span class="w"> </span><span class="n">states</span><span class="p">:</span><span class="n">CLOSED</span><span class="p">)</span><span class="w"> </span><span class="p">{</span><span class="w">
      </span><span class="n">edges</span><span class="w"> </span><span class="p">{</span><span class="w">
        </span><span class="n">node</span><span class="w"> </span><span class="p">{</span><span class="w">
          </span><span class="n">title</span><span class="w">
          </span><span class="n">url</span><span class="w">
          </span><span class="n">labels</span><span class="p">(</span><span class="n">first</span><span class="p">:</span><span class="mi">5</span><span class="p">)</span><span class="w"> </span><span class="p">{</span><span class="w">
            </span><span class="n">edges</span><span class="w"> </span><span class="p">{</span><span class="w">
              </span><span class="n">node</span><span class="w"> </span><span class="p">{</span><span class="w">
                </span><span class="n">name</span><span class="w">
              </span><span class="p">}</span><span class="w">
            </span><span class="p">}</span><span class="w">
          </span><span class="p">}</span><span class="w">
        </span><span class="p">}</span><span class="w">
      </span><span class="p">}</span><span class="w">
    </span><span class="p">}</span><span class="w">
  </span><span class="p">}</span><span class="w">
</span><span class="p">}</span><span class="w">
</span></code></pre>


<p>Looking at the composition line by line:</p>

<ul>
<li>
<p><code>query {</code></p>

<p>Because we want to read data from the server, not modify it, <code>query</code> is the root operation. (If you don't specify an operation, <code>query</code> is also the default.)</p>
</li>
<li>
<p><code>repository(owner:"octocat", name:"Hello-World") {</code></p>

<p>To begin the query, we want to find a <a href="/v4/object/repository/"><code>repository</code></a> object. The schema validation indicates this object requires an <code>owner</code> and a <code>name</code> argument.</p>
</li>
<li>
<p><code>issues(last:20, states:CLOSED) {</code></p>

<p>To account for all issues in the repository, we call the <code>issues</code> object. (We <em>could</em> query a single <code>issue</code> on a <code>repository</code>, but that would require us to know the number of the issue we want to return and provide it as an argument.)</p>

<p>Some details about the <code>issues</code> object:</p>

<ul>
<li>The <a href="/v4/object/repository/">docs</a> tell us this object has the type <code>IssueConnection</code>.</li>
<li>Schema validation indicates this object requires a <code>last</code> or <code>first</code> number of results as an argument, so we provide <code>20</code>.</li>
<li>The <a href="/v4/object/repository/">docs</a> also tell us this object accepts a <code>states</code> argument, which is an  <a href="/v4/enum/issuestate/"><code>IssueState</code></a> enum that accepts <code>OPEN</code> or <code>CLOSED</code> values. To find only closed issues, we give the <code>states</code> key a value of <code>CLOSED</code>.</li>
</ul>
</li>
<li>
<p><code>edges {</code></p>

<p>We know <code>issues</code> is a connection because it has the <code>IssueConnection</code> type. To retrieve data about individual issues, we have to access the node via <code>edges</code>.</p>
</li>
<li>
<p><code>node {</code></p>

<p>Here we retrieve the node at the end of the edge. The <a href="/v4/object/issueconnection"><code>IssueConnection</code> docs</a> indicate the node at the end of the <code>IssueConnection</code> type is an <code>Issue</code> object.</p>
</li>
<li>
<p>Now that we know we're retrieving an <code>Issue</code> object, we can look at the <a href="/v4/object/issue">docs</a> and specify the fields we want to return:</p>

<pre class="highlight highlight-graphql"><code><span class="err">title</span><span class="w">
</span><span class="err">url</span><span class="w">
</span><span class="err">labels(first:5)</span><span class="w"> </span><span class="p">{</span><span class="w">
  </span><span class="n">edges</span><span class="w"> </span><span class="p">{</span><span class="w">
    </span><span class="n">node</span><span class="w"> </span><span class="p">{</span><span class="w">
      </span><span class="n">name</span><span class="w">
    </span><span class="p">}</span><span class="w">
  </span><span class="p">}</span><span class="w">
</span><span class="p">}</span><span class="w">
</span></code></pre>


<p>Here we specify the <code>title</code>, <code>url</code>, and <code>labels</code> fields of the <code>Issue</code> object.</p>

<p>The <code>labels</code> field has the type <a href="/v4/object/labelconnection/"><code>LabelConnection</code></a>. As with the <code>issues</code> object, because <code>labels</code> is a connection, we must travel its edges to a connected node: the <code>label</code> object. At the node, we can specify the <code>label</code> object fields we want to return, in this case, <code>name</code>.</p>
</li>
</ul>

<p>You may notice that running this query on the Octocat's public <code>Hello-World</code> repository won't return many labels. Try running it on one of your own repositories that does use labels, and you'll likely see a difference.</p>

<h2>
<a id="example-mutation" class="anchor" href="#example-mutation" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Example mutation</h2>

<p>Mutations often require information that you can only find out by performing a query first. This example shows two operations:</p>

<ol>
<li>A query to get an issue ID.</li>
<li>A mutation to add an emoji reaction to the issue.</li>
</ol>

<p class="explorer-link"><a href="/v4/explorer/?variables=%7B%7D&amp;query=query%20FindIssueID%20%7B%0A%20%20repository%28owner%3A%22octocat%22%2C%20name%3A%22Hello-World%22%29%20%7B%0A%20%20%20%20issue%28number%3A349%29%20%7B%0A%20%20%20%20%20%20id%0A%20%20%20%20%7D%0A%20%20%7D%0A%7D%0A%0Amutation%20AddReactionToIssue%20%7B%0A%20%20addReaction%28input%3A%7BsubjectId%3A%22MDU6SXNzdWUyMzEzOTE1NTE%3D%22%2Ccontent%3AHOORAY%7D%29%20%7B%0A%20%20%20%20reaction%20%7B%0A%20%20%20%20%20%20content%0A%20%20%20%20%7D%0A%20%20%20%20subject%20%7B%0A%20%20%20%20%20%20id%0A%20%20%20%20%7D%0A%20%20%7D%0A%7D">Run in Explorer</a></p>

<pre class="highlight highlight-graphql"><code><span class="k">query</span><span class="w"> </span><span class="n">FindIssueID</span><span class="w"> </span><span class="p">{</span><span class="w">
  </span><span class="n">repository</span><span class="p">(</span><span class="n">owner</span><span class="p">:</span><span class="s2">"octocat"</span><span class="p">,</span><span class="w"> </span><span class="n">name</span><span class="p">:</span><span class="s2">"Hello-World"</span><span class="p">)</span><span class="w"> </span><span class="p">{</span><span class="w">
    </span><span class="n">issue</span><span class="p">(</span><span class="n">number</span><span class="p">:</span><span class="mi">349</span><span class="p">)</span><span class="w"> </span><span class="p">{</span><span class="w">
      </span><span class="n">id</span><span class="w">
    </span><span class="p">}</span><span class="w">
  </span><span class="p">}</span><span class="w">
</span><span class="p">}</span><span class="w">

</span><span class="k">mutation</span><span class="w"> </span><span class="n">AddReactionToIssue</span><span class="w"> </span><span class="p">{</span><span class="w">
  </span><span class="n">addReaction</span><span class="p">(</span><span class="n">input</span><span class="p">:{</span><span class="n">subjectId</span><span class="p">:</span><span class="s2">"MDU6SXNzdWUyMzEzOTE1NTE="</span><span class="p">,</span><span class="n">content</span><span class="p">:</span><span class="n">HOORAY</span><span class="p">})</span><span class="w"> </span><span class="p">{</span><span class="w">
    </span><span class="n">reaction</span><span class="w"> </span><span class="p">{</span><span class="w">
      </span><span class="n">content</span><span class="w">
    </span><span class="p">}</span><span class="w">
    </span><span class="n">subject</span><span class="w"> </span><span class="p">{</span><span class="w">
      </span><span class="n">id</span><span class="w">
    </span><span class="p">}</span><span class="w">
  </span><span class="p">}</span><span class="w">
</span><span class="p">}</span><span class="w">
</span></code></pre>


<div class="alert tip">

<p>Although you can include a query and a mutation in the same Explorer window if you give them names (<code>FindIssueID</code> and <code>AddReactionToIssue</code> in this example), the operations will be executed as separate calls to the GraphQL endpoint. It's not possible to perform a query at the same time as a mutation, or vice versa.</p>

</div>

<p>Let's walk through the example. The task sounds simple: add an emoji reaction to an issue.</p>

<p>So how do we know to begin with a query? We don't, yet.</p>

<p>Because we want to modify data on the server (attach an emoji to an issue), we begin by searching the schema for a helpful mutation. The reference docs show the <a href="/v4/mutation/addreaction"><code>addReaction</code></a> mutation, with this description: <code>Adds a reaction to a subject.</code> Perfect!</p>

<p>The docs for the mutation list three input fields:</p>

<ul>
<li>
<code>clientMutationId</code> (<code>String</code>)</li>
<li>
<code>subjectId</code> (<code>ID!</code>)</li>
<li>
<code>content</code> (<code>ReactionContent!</code>)</li>
</ul>

<p>The <code>!</code>s indicate that <code>subjectId</code> and <code>content</code> are required fields. A required <code>content</code> makes sense: we want to add a reaction, so we'll need to specify which emoji to use.</p>

<p>But why is <code>subjectId</code> required? It's because the <code>subjectId</code> is the only way to identify <em>which</em> issue in <em>which</em> repository to react to.</p>

<p>This is why we start this example with a query: to get the <code>ID</code>.</p>

<p>Let's examine the query line by line:</p>

<ul>
<li>
<p><code>query FindIssueID {</code></p>

<p>Here we're performing a query, and we name it <code>FindIssueID</code>. Note that naming a query is optional; we give it a name here so that we can include it in same Explorer window as the mutation.</p>
</li>
<li>
<p><code>repository(owner:"octocat", name:"Hello-World") {</code></p>

<p>We specify the repository by querying the <code>repository</code> object and passing <code>owner</code> and <code>name</code> arguments.</p>
</li>
<li>
<p><code>issue(number:349) {</code></p>

<p>We specify the issue to react to by querying the <code>issue</code> object and passing a <code>number</code> argument.</p>
</li>
<li>
<p><code>id</code></p>

<p>This is where we retrieve the <code>id</code> of <code>https://github.com/octocat/Hello-World/issues/349</code> to pass as the <code>subjectId</code>.</p>
</li>
</ul>

<p>When we run the query, we get the <code>id</code>: <code>MDU6SXNzdWUyMzEzOTE1NTE=</code></p>

<div class="alert tip">

<p><strong>Note</strong>: The <code>id</code> returned in the query is the value we'll pass as the <code>subjectID</code> in the mutation. Neither the docs nor schema introspection will indicate this relationship; you'll need to understand the concepts behind the names to figure this out.</p>

</div>

<p>With the ID known, we can proceed with the mutation:</p>

<ul>
<li>
<p><code>mutation AddReactionToIssue {</code></p>

<p>Here we're performing a mutation, and we name it <code>AddReactionToIssue</code>. As with queries, naming a mutation is optional; we give it a name here so we can include it in the same Explorer window as the query.</p>
</li>
<li>
<p><code>addReaction(input:{subjectId:"MDU6SXNzdWUyMzEzOTE1NTE=",content:HOORAY}) {</code></p>

<p>Let's examine this line:</p>

<ul>
<li>
<code>addReaction</code> is the name of the mutation.</li>
<li>
<code>input</code> is the required argument key. This will always be <code>input</code> for a mutation.</li>
<li>
<code>{subjectId:"MDU6SXNzdWUyMzEzOTE1NTE=",content:HOORAY}</code> is the required argument value. This will always be an <a href="/v4/input_object/">input object</a> (hence the curly braces) composed of input fields (<code>subjectId</code> and <code>content</code> in this case) for a mutation.</li>
</ul>

<p>How do we know which value to use for the content? The <a href="/v4/mutation/addreaction/"><code>addReaction</code> docs</a> tell us the <code>content</code> field has the type <a href="/v4/enum/reactioncontent/"><code>ReactionContent</code></a>, which is an <a href="/v4/enum">enum</a> because only certain emoji reactions are supported on GitHub issues. These are the allowed values for reactions (note some values differ from their corresponding emoji names):</p>

<table>
<thead>
<tr>
<th>content</th>
<th>emoji</th>
</tr>
</thead>
<tbody>
<tr>
<td><code>+1</code></td>
<td><img class="emoji" title=":+1:" alt=":+1:" src="https://github.githubassets.com/images/icons/emoji/unicode/1f44d.png" height="20" width="20" align="absmiddle"></td>
</tr>
<tr>
<td><code>-1</code></td>
<td><img class="emoji" title=":-1:" alt=":-1:" src="https://github.githubassets.com/images/icons/emoji/unicode/1f44e.png" height="20" width="20" align="absmiddle"></td>
</tr>
<tr>
<td><code>laugh</code></td>
<td><img class="emoji" title=":smile:" alt=":smile:" src="https://github.githubassets.com/images/icons/emoji/unicode/1f604.png" height="20" width="20" align="absmiddle"></td>
</tr>
<tr>
<td><code>confused</code></td>
<td><img class="emoji" title=":confused:" alt=":confused:" src="https://github.githubassets.com/images/icons/emoji/unicode/1f615.png" height="20" width="20" align="absmiddle"></td>
</tr>
<tr>
<td><code>heart</code></td>
<td><img class="emoji" title=":heart:" alt=":heart:" src="https://github.githubassets.com/images/icons/emoji/unicode/2764.png" height="20" width="20" align="absmiddle"></td>
</tr>
<tr>
<td><code>hooray</code></td>
<td><img class="emoji" title=":tada:" alt=":tada:" src="https://github.githubassets.com/images/icons/emoji/unicode/1f389.png" height="20" width="20" align="absmiddle"></td>
</tr>
<tr>
<td><code>rocket</code></td>
<td><img class="emoji" title=":rocket:" alt=":rocket:" src="https://github.githubassets.com/images/icons/emoji/unicode/1f680.png" height="20" width="20" align="absmiddle"></td>
</tr>
<tr>
<td><code>eyes</code></td>
<td><img class="emoji" title=":eyes:" alt=":eyes:" src="https://github.githubassets.com/images/icons/emoji/unicode/1f440.png" height="20" width="20" align="absmiddle"></td>
</tr>
</tbody>
</table>
</li>
<li>
<p>The rest of the call is composed of the payload object. This is where we specify the data we want the server to return after we've performed the mutation. These lines come from the <a href="/v4/mutation/addreaction"><code>addReaction</code> docs</a>, which three possible return fields:</p>

<ul>
<li>
<code>clientMutationId</code> (<code>String</code>)</li>
<li>
<code>reaction</code> (<code>Reaction!</code>)</li>
<li>
<code>subject</code> (<code>Reactable!</code>)</li>
</ul>

<p>In this example, we return the two required fields (<code>reaction</code> and <code>subject</code>), both of which have required subfields (respectively, <code>content</code> and <code>id</code>).</p>
</li>
</ul>

<p>When we run the mutation, this is the response:</p>

<pre class="highlight highlight-json"><code><span class="p">{</span><span class="w">
  </span><span class="nt">"data"</span><span class="p">:</span><span class="w"> </span><span class="p">{</span><span class="w">
    </span><span class="nt">"addReaction"</span><span class="p">:</span><span class="w"> </span><span class="p">{</span><span class="w">
      </span><span class="nt">"reaction"</span><span class="p">:</span><span class="w"> </span><span class="p">{</span><span class="w">
        </span><span class="nt">"content"</span><span class="p">:</span><span class="w"> </span><span class="s2">"HOORAY"</span><span class="w">
      </span><span class="p">},</span><span class="w">
      </span><span class="nt">"subject"</span><span class="p">:</span><span class="w"> </span><span class="p">{</span><span class="w">
        </span><span class="nt">"id"</span><span class="p">:</span><span class="w"> </span><span class="s2">"MDU6SXNzdWUyMTc5NTQ0OTc="</span><span class="w">
      </span><span class="p">}</span><span class="w">
    </span><span class="p">}</span><span class="w">
  </span><span class="p">}</span><span class="w">
</span><span class="p">}</span><span class="w">
</span></code></pre>


<p>That's it! Check out your <a href="https://github.com/octocat/Hello-World/issues/349">reaction to the issue</a> by hovering over the <img class="emoji" title=":tada:" alt=":tada:" src="https://github.githubassets.com/images/icons/emoji/unicode/1f389.png" height="20" width="20" align="absmiddle"> to find your username.</p>

<p>One final note: when you pass multiple fields in an input object, the syntax can get unwieldy. Moving the fields into a <a href="#working-with-variables">variable</a> can help. Here's how you could rewrite the original mutation using a variable:</p>

<p class="explorer-link"><a href="/v4/explorer/?variables=%20%7B%0A%20%20%22myVar%22%3A%20%7B%0A%20%20%20%20%22subjectId%22%3A%22MDU6SXNzdWUyMTc5NTQ0OTc%3D%22%2C%0A%20%20%20%20%22content%22%3A%22HOORAY%22%0A%20%20%7D%0A%7D&amp;query=mutation%28%24myVar%3AAddReactionInput%21%29%20%7B%0A%20%20addReaction%28input%3A%24myVar%29%20%7B%0A%20%20%20%20reaction%20%7B%0A%20%20%20%20%20%20content%0A%20%20%20%20%7D%0A%20%20%20%20subject%20%7B%0A%20%20%20%20%20%20id%0A%20%20%20%20%7D%0A%20%20%7D%0A%7D%0A">Run in Explorer</a></p>

<pre class="highlight highlight-graphql"><code><span class="k">mutation</span><span class="p">(</span><span class="nv">$myVar</span><span class="p">:</span><span class="n">AddReactionInput</span><span class="p">!)</span><span class="w"> </span><span class="p">{</span><span class="w">
  </span><span class="n">addReaction</span><span class="p">(</span><span class="n">input</span><span class="p">:</span><span class="nv">$myVar</span><span class="p">)</span><span class="w"> </span><span class="p">{</span><span class="w">
    </span><span class="n">reaction</span><span class="w"> </span><span class="p">{</span><span class="w">
      </span><span class="n">content</span><span class="w">
    </span><span class="p">}</span><span class="w">
    </span><span class="n">subject</span><span class="w"> </span><span class="p">{</span><span class="w">
      </span><span class="n">id</span><span class="w">
    </span><span class="p">}</span><span class="w">
  </span><span class="p">}</span><span class="w">
</span><span class="p">}</span><span class="w">
</span><span class="err">variables</span><span class="w"> </span><span class="p">{</span><span class="w">
  </span><span class="err">"</span><span class="n">myVar</span><span class="err">":</span><span class="w"> </span><span class="p">{</span><span class="w">
    </span><span class="err">"</span><span class="n">subjectId</span><span class="err">":"</span><span class="n">MDU6SXNzdWUyMTc5NTQ0OTc</span><span class="err">="</span><span class="p">,</span><span class="w">
    </span><span class="err">"</span><span class="n">content</span><span class="err">":"</span><span class="n">HOORAY</span><span class="err">"</span><span class="w">
  </span><span class="p">}</span><span class="w">
</span><span class="p">}</span><span class="w">
</span></code></pre>


<div class="alert note">

<p>You may notice that the <code>content</code> field value in the earlier example (where it's used directly in the mutation) does not have quotes around <code>HOORAY</code>, but it does have quotes when used in the variable. There's a reason for this:</p>

<ul>
<li>When you use <code>content</code> directly in the mutation, the schema expects the value to be of type <a href="/v4/enum/reactioncontent/"><code>ReactionContent</code></a>, which is an <em>enum</em>, not a string. Schema validation will throw an error if you add quotes around the enum value, as quotes are reserved for strings.</li>
<li>When you use <code>content</code> in a variable, the variables section must be valid JSON, so the quotes are required. Schema validation correctly interprets the <code>ReactionContent</code> type when the variable is passed into the mutation during execution.</li>
</ul>

<p>For more information on the difference between enums and strings, see the <a href="https://graphql.github.io/graphql-spec/June2018/#sec-Enums">official GraphQL spec</a>.</p>

</div>

<h2>
<a id="further-reading" class="anchor" href="#further-reading" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Further reading</h2>

<p>There is a <em>lot</em> more you can do when forming GraphQL calls. Here are some places to look next:</p>

<ul>
<li><a href="https://graphql.github.io/learn/pagination/">Pagination</a></li>
<li><a href="https://graphql.github.io/learn/queries/#fragments">Fragments</a></li>
<li><a href="https://graphql.github.io/learn/queries/#inline-fragments">Inline fragments</a></li>
<li><a href="https://graphql.github.io/learn/queries/#directives">Directives</a></li>
</ul>
      </div>

      <div class="nav-select nav-select-bottom hide-lg hide-xl">
        <select class="form-select mt-4" onchange="if (this.value) window.location.href=this.value">
  <option value="">Navigate the docs…</option>
  <optgroup label="Guides">
    <option value="/v4/guides/">Overview</option>
    <option value="/v4/guides/intro-to-graphql/">Intro to GraphQL</option>
    <option value="/v4/guides/forming-calls/">Forming Calls</option>
    <option value="/v4/guides/using-global-node-ids/">Using Global Node IDs</option>
    <option value="/v4/guides/migrating-from-rest/">Migrating from REST</option>
    <option value="/v4/guides/using-the-explorer/">Using the Explorer</option>
    <option value="/v4/guides/managing-enterprise-accounts/">Managing enterprise accounts</option>
    <option value="/v4/guides/resource-limitations/">Resource Limitations</option>
  </optgroup>
</select>

      </div>

      <div id="js-sidebar" class="sidebar-shell col-md-4 hide-sm hide-md d-md-block d-lg-block d-xl-block">
        <div class="sidebar-module sidebar-menu">
          <ul>
            <li class="js-topic"><h3 class="standalone"><a href="/v4/guides/">Overview</a></h3></li>
            <li class="js-topic"><h3 class="standalone"><a href="/v4/guides/intro-to-graphql/">Intro to GraphQL</a></h3></li>
            <li class="js-topic"><h3 class="standalone"><a href="/v4/guides/forming-calls/">Forming Calls</a></h3></li>
            <li class="js-topic"><h3 class="standalone"><a href="/v4/guides/using-global-node-ids/">Using Global Node IDs</a></h3></li>
            <li class="js-topic"><h3 class="standalone"><a href="/v4/guides/migrating-from-rest/">Migrating from REST</a></h3></li>
            <li class="js-topic"><h3 class="standalone"><a href="/v4/guides/using-the-explorer/">Using the Explorer</a></h3></li>
            <li class="js-topic"><h3 class="standalone"><a href="/v4/guides/managing-enterprise-accounts/">Managing enterprise accounts</a></h3></li>
            <li class="js-topic"><h3 class="standalone"><a href="/v4/guides/resource-limitations/">Resource Limitations</a></h3></li>
          </ul>
        </div>

        
        <div class="sidebar-module api-status py-4 text-center"><a href="https://status.github.com" class="unknown">API Status</a></div>

        
      </div><!-- sidebar-shell -->
    </section>
  </div>

  <footer class="footer text-muted">
  <div class="container">
    <span class="footer-legal">&copy; 2020 GitHub Inc. All rights reserved.</span>
    <span class="mega-octicon octicon-mark-github footer-mark"></span>
    <nav class="footer-nav">
      <a class="footer-nav-item" href="https://help.github.com/articles/github-terms-of-service">Terms of service</a>
      <a class="footer-nav-item" href="https://github.com/site/privacy">Privacy</a>
      <a class="footer-nav-item" href="https://github.com/security">Security</a>
      <a class="footer-nav-item" href="https://github.com/support">Support</a>
    </nav>
  </div>
</footer>

<script>
  (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
  (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
  m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
  })(window,document,'script','//www.google-analytics.com/analytics.js','ga');

  ga('create', 'UA-3769691-37', 'github.com');
  ga('send', 'pageview');
</script>

</body>
</html>
